'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 SKPLAYER                                 |
'|                                                                          |
'|                  Show how to create a WinLIFT CD-player.                 |
'|                                                                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                       http://www.zapsolution.com                         |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'|                   copyright (c) 1999 Patrice TERRIER                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 02-21-2000                         |
'|                        Last revised : 02-21-2000                         |
'+--------------------------------------------------------------------------+

' ** Eliminate unnecessary macros
%NOANIMATE    = 1
%NODRAGLIST   = 1
%NOHEADER     = 1
%NOIMAGELIST  = 1
%NOLISTVIEW   = 1
%NOTABCONTROL = 1
'%NOTRACKBAR   = 1
%NOTREEVIEW   = 1
%NOUPDOWN     = 1

%NOBUTTON     = 1
%NOCOMBOEX    = 1
%NOEDIT       = 1
%NOCOMBO      = 1
%NOLIST       = 1
%WINAPI       = 1
%NOREBAR      = 1
%NOTOOLBAR    = 1
%NOTOOLTIPS   = 1
'%NOSTATUSBAR  = 1

#COMPILE EXE

#INCLUDE "WIN32API.INC"
#INCLUDE "COMMCTRL.INC"
#INCLUDE "SKENGINE.INC"
#RESOURCE "SKPLAYER.PBR"

GLOBAL hInst&
GLOBAL hFrame&, hMenu&, hCTL&, hStatus&
GLOBAL sk AS SKALL
GLOBAL zTmp AS ASCIIZ * 256
GLOBAL ScrWidth&, ScrHeight&
GLOBAL xFrame&, yFrame&

DECLARE SUB CopyMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (lpDest AS ANY, lpSource AS ANY, BYVAL cb&)

DECLARE FUNCTION CDPlay& (Fplaying&)
DECLARE FUNCTION CDStop& (Fplaying&)
DECLARE FUNCTION CDInit& (Fplaying&)
DECLARE FUNCTION CDEject& (Fplaying&)
DECLARE FUNCTION CDInsert& (Fplaying&)
DECLARE FUNCTION CDPause& (Fplaying&)
DECLARE FUNCTION CDTrackNext& (Fplaying&)
DECLARE FUNCTION CDFastForward& (Fplaying&)
DECLARE FUNCTION CDRewind& (Fplaying&)
DECLARE FUNCTION CDTrackPrevious& (Fplaying&)

DECLARE FUNCTION skGetMasterVolume& (ByVal hmixer&, mxc AS MIXERCONTROL)
DECLARE FUNCTION skSetMasterVolume& (ByVal hmixer&, mxc AS MIXERCONTROL, BYVAL volume&)

DECLARE FUNCTION But3D&(BYVAL hOwner&, BYVAL Button$, BYVAL Tip$, BYVAL Fonte&, BYVAL Text$, xLeft&, BYVAL yLeft&, BYVAL btWidth&, BYVAL btHeight&, BYVAL ButID&, BYVAL Mode&)

' Message function
FUNCTION WndProc&(BYVAL hWnd&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&)

    LOCAL rc AS RECT
    LOCAL ps AS PAINTSTRUCT
    LOCAL dinfo AS DOCINFO
    LOCAL wMsg AS tagMsg

    STATIC hBut&(), Fplaying&, Vol&, WasPercent&, hProgress&
    STATIC hMixer&, volCtrl AS MIXERCONTROL

    DIM hBut&(14)

    Ret& = skGetMessage(hWnd&, Msg&, wParam&, lParam&) ' Call the Skin Engine !!!
    IF Ret& THEN FUNCTION = Ret&: EXIT FUNCTION        

    wP% = LOWRD(wParam&): ID% = HIWRD(wParam&)

    SELECT CASE Msg&
    CASE %WM_INITDIALOG 'CREATE

         xLeft& = 4
         yTop& = 4
         X& = xLeft& 
         Y& = yTop&
         xStep& = 0
         ButWidth& = 30
         ButHeight& = 20
         MarlettFont& = skMarlett(12)

         Obj& = 1

         hBut&(Obj&) = skBut3D&(hCTL&, "|<", skCaptionFont, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Previous track")
         CALL skTabStop(hBut&(Obj&))

         INCR Obj&
         X& = X& + ButWidth& + xStep&
         hBut&(Obj&) = skBut3D&(hCTL&, "<<", skCaptionFont, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Fast rewind")
         CALL skTabStop(hBut&(Obj&))
         
         INCR Obj&
         X& = X& + ButWidth& + xStep&
         hBut&(Obj&) = skBut3D&(hCTL&, "7", MarlettFont&, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Eject CD-ROM")
         CALL skTabStop(hBut&(Obj&))
         
         INCR Obj&
         X& = X& + ButWidth& + xStep&
         hBut&(Obj&) = skBut3D&(hCTL&, "v", MarlettFont&, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Insert CD-ROM")
         CALL skTabStop(hBut&(Obj&))
         
         INCR Obj&
         X& = X& + ButWidth& + xStep&
         sk.Y = 2
         hBut&(Obj&) = skBut3D&(hCTL&, "8", MarlettFont&, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Playing")
         CALL skTabStop(hBut&(Obj&))

         INCR Obj&
         X& = X& + ButWidth& + xStep&
         sk.Y = 0
         hBut&(Obj&) = skBut3D&(hCTL&, CHR$(31,31), skCaptionFont, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Pause")
         CALL skTabStop(hBut&(Obj&))

         INCR Obj&
         X& = X& + ButWidth& + xStep&
         sk.Y = 2
         hBut&(Obj&) = skBut3D&(hCTL&, "g", MarlettFont&, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Stop playing")
         CALL skTabStop(hBut&(Obj&))

'         INCR Obj&
'         X& = X& + ButWidth& + xStep&
'         sk.Y = 0
'         hBut&(Obj&) = skBut3D&(hCTL&, "r", MarlettFont&, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
'         CALL skButtonTip(hCTL&, hBut&(Obj&), "Close player")
'         CALL skTabStop(hBut&(Obj&))

         INCR Obj&
         X& = X& + ButWidth& + xStep&
         hBut&(Obj&) = skBut3D&(hCTL&, ">>", skCaptionFont, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Fast forward")
         CALL skTabStop(hBut&(Obj&))

         INCR Obj&
         X& = X& + ButWidth& + xStep&
         hBut&(Obj&) = skBut3D&(hCTL&, ">|", skCaptionFont, X&, Y&, ButWidth&, ButHeight&, Obj&, sk)   
         CALL skButtonTip(hCTL&, hBut&(Obj&), "Next track")
         CALL skTabStop(hBut&(Obj&))

         CALL skDeleteObject(MarlettFont&)

       ' Get the master volume
         Vol& = skGetMasterVolume&(hMixer&, volCtrl)
         Percent& = CLNG((Vol& / 65535) * 100)
         WasPercent& = Percent&

         INCR Obj&
         Style& = %WS_CHILD OR %WS_VISIBLE OR %TBS_BOTH OR %TBS_NOTICKS OR %WS_TABSTOP
         StyleEx& = %WS_EX_CLIENTEDGE
         hProgress& = CreateWindowEx(StyleEx&, "msctls_trackbar32", "", Style&, xLeft&, yTop& * 2 + ButHeight&, (ButWidth& + xStep&) * (Obj& - 1) - xStep&, ButHeight&, hCTL&, Obj&, hInst&, BYVAL %NULL)
         CALL skSetColor(hProgress&, 0, RGB(164,164,164))'RGB(164,139,65)) ' Background color
         CALL SendMessage(hProgress&, %TBM_SETRANGE, %TRUE, MAKLNG(0,100))
         CALL SendMessage(hProgress&, %TBM_SETPAGESIZE, 0, 5)
         CALL SendMessage(hProgress&, %TBM_SETPOS, %TRUE, Percent&)


'*'call skSetCTLtext(hStatus&, str$((ButWidth& + xStep&) * (Obj& - 1) - xStep& + xLeft& * 2) + str$(yTop& * 3 + ButHeight& * 2))

         CALL SetFocus(hBut&(5))

         Ret& = CDInit(Fplaying&)

    CASE %WM_HSCROLL
         Percent& = SendMessage(hProgress&, %tbm_getpos, 0, 0)
         
         IF Percent& <> WasPercent& THEN
            Vol& = Percent& * 655
            ok& = skSetMasterVolume(hMixer&, volCtrl, Vol&)
         END IF
         WasPercent& = Percent&

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         SELECT CASE hWnd&
         CASE hCTL& 
         
            IF (GetWindowLong(hCTL&, %GWL_STYLE) AND %WS_CLIPCHILDREN) THEN
               CALL InvalidateRect(hCTL&, BYVAL %NULL, 0)
            END IF

            CALL GetClientRect(hWnd&, rc)
            Xin& = rc.nRight: Yin& = rc.nBottom
            hDC& = BeginPaint(hWnd&, ps)

            IF (GetWindowLong(hCTL&, %GWL_STYLE) AND %WS_CLIPCHILDREN) = 0 THEN
               CALL skTileBlt(hDC&, 0, 0, Xin&, Yin&, skCtlBack)
            END IF

            CALL EndPaint(hWnd&, ps)

            FUNCTION = 1: EXIT FUNCTION
         END SELECT       

    CASE %WM_SYSCOMMAND
	 IF wParam& = %SC_CLOSE THEN

            DIM cXY AS POINTAPI
	    CALL ShowWindow(hFrame&, %SW_RESTORE)
	    CALL GetWindowRect(hFrame&, rc)
	    Wdth& =  rc.nRight - rc.nLeft
	    Hght& = rc.nBottom - rc.nTop
            cXY.X = 0: cXY.Y = 0: CALL ClientToScreen(hFrame&, cXY)
	    CALL Config(cXY.X, cXY.Y, Wdth&, Hght&, 1)

            CALL PostQuitMessage(0)
	    FUNCTION = 1: EXIT FUNCTION

	 ELSEIF wParam& = 0 THEN

            tNotify$ = skAuthor$ + "||ZAP Image solution|http://www.zapsolution.com|e-mail: pterrier@infonie.fr|| copyright " + RIGHT$(DATE$, 4) + " Patrice Terrier|All rights reserved."
	    sk.Icon = LoadIcon(hInst&, "PROGRAM")
	    sk.Edge = %EDGE_ETCHED
	    sk.Just = %SK_CENTERED
	    sk.Effect = %SK_CENTERED
            sk.Print3D = %SK_3DOUT
            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
	    UseButton$ = "" ' Uses the default "ok" button

            CALL skMsgBox(hFrame&, skCaptionFont, skGetCTLText(hFrame&), tNotify$, UseButton$, sk)

	 END IF

    CASE %WM_COMMAND

         SELECT CASE wP%
         CASE 1 ' Track previous
            Ret& = CDTrackPrevious(Fplaying&)
         CASE 2 ' Fast Rewind
            Ret& = CDRewind&(Fplaying&)
         CASE 3 ' Eject CD
            Ret& = CDEject(Fplaying&)
         CASE 4 ' Insert CD
            Ret& = CDInsert(Fplaying&)
         CASE 5 ' Play CD
            Ret& = CDPlay(Fplaying&)
         CASE 6 ' Pause CD
            Ret& = CDPause(Fplaying&)
         CASE 7 ' Stop CD
            Ret& = CDStop(Fplaying&)
         CASE 8 ' Fast forward
            Ret& = CDFastForward&(Fplaying&)
         CASE 9 ' Track next
            Ret& = CDTrackNext(Fplaying&)
         END SELECT

    CASE %WM_DESTROY
         
       ' Kill the button bitmap resource
         FOR K& = 1 TO 10
             CALL skDeleteMemBMP(hBut&(K&)) 
         NEXT

    END SELECT

    FUNCTION = DefWindowProc(hWnd&, Msg&, wParam&, lParam&)

END FUNCTION

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
		  BYVAL hPrevInstance AS LONG, _
		  lpCmdLine           AS ASCIIZ PTR, _
		  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL rc          AS RECT
    LOCAL wc          AS WndClassEx
    LOCAL szClassName AS ASCIIZ * 32

    hInst& = hInstance&

    hIcon& = LoadIcon(hInstance&, "PROGRAM")

    ScrWidth& = GetSystemMetrics(%SM_CXSCREEN)
    ScrHeight& = GetSystemMetrics(%SM_CYSCREEN)

'--------------------------------------------------------------------------------
'   Skin Engine. 
'--------------------------------------------------------------------------------

    zTmp = "WinLIFT CD player"
    szClassName = "SKINSDI"
    Style& = %CS_HREDRAW OR %CS_VREDRAW 
    
    wc.cbSize        = SIZEOF(wc)
    wc.style         = Style&
    wc.lpfnWndProc   = CODEPTR(WndProc)
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = hInst&
    wc.hIcon         = %NULL
    wc.hCursor       = %NULL ' LoadCursor(%NULL, BYVAL %IDC_ARROW)
    wc.hbrBackground = %NULL ' Don't paint the class window background
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR(szClassName)
    wc.hIconSm       = LoadIcon(hInst&,"PROGRAM")

    CALL RegisterClassEx(wc)
 
'--------------------------------------------------------------------------------
'   Skin Engine
'--------------------------------------------------------------------------------
'   Tells the engine it should use 
    CALL skWindowStyle(%SK_MINIMIZEBOX OR _        ' MINIMIZEBOX button 
                       %SK_CLOSEBOX OR _           ' CLOSEBOX button
                       %SK_DOCKBOX)' OR _          ' DOCKBOX button
'                      %SK_STATUSBAR)              ' STATUSBAR bottom status bar

'   Tell the engine the default client size for our window Xin&, Yin&.
'   Returns xFrame&, yFrame& as the whole external size of the skinned window.
    Xin& = 278: Yin& = 52
    CALL skSetMaxSize(Xin&, Yin&, xFrame&, yFrame&)
'--------------------------------------------------------------------------------
  
  ' Retrieves last user window coordinates in the config file
    CALL Config(x&, y&, Wdth&, Hght&, 0)

    Style& = %WS_POPUP OR %WS_SYSMENU 'OR %WS_CLIPCHILDREN
    StyleEx& = 0
    hFrame& = CreateWindowEx(StyleEx&, _
                          szClassName, _           ' window class name
                          zTmp, _                  ' window title
                          Style&, _                ' window style
                          x&, _                    ' initial x position
                          y&, _                    ' initial y position
                          xFrame&, _               ' initial x size
                          yFrame&, _               ' initial y size
                          %NULL, _                 ' parent window handle
                          %NULL, _                 ' window menu handle
                          hInst&, _                ' program instance handle
                          BYVAL %NULL)             ' creation parameters
  
'--------------------------------------------------------------------------------
'   Skin Engine
'--------------------------------------------------------------------------------
  ' Create control holder
    hCTL& = skHolder(hFrame&, "SKCLIP", 0, 0, CODEPTR(WndProc))
    
  ' Create the status bar window %SK_STATUSBAR must be specified
    '*'hStatus& = skStatusWindow(hFrame&, "")      ' in the skWindowStyle function.

'--------------------------------------------------------------------------------


    CALL WndProc(hFrame&, %WM_INITDIALOG, 0, 0)
        
    CALL ShowWindow(hFrame&, %SW_SHOW)
    CALL UpdateWindow(hFrame&)

    WHILE GetMessage(Msg, %NULL, 0, 0)
      
     ' Let the Skin Engine handle the TAB key and ALT keys for the menu bar
     ' and some other stuffs as well (like animations)
       IF skDialogMessage(hFrame&, Msg) = %FALSE THEN
       
        ' Allow the system to handle the %WS_TABSTOP controls
          IF IsDialogMessage(hFrame&, Msg) = %FALSE THEN
       
             TranslateMessage Msg
             DispatchMessage Msg
             
          END IF
          
       END IF       
       
    WEND

    FUNCTION = msg.wParam

END FUNCTION

FUNCTION GetVolumeControl&(BYVAL hmixer&, BYVAL componentType&, _
                           BYVAL ctrlType&, mxc AS MIXERCONTROL) EXPORT

  ' This function attempts to obtain a mixer control.
  ' Returns True if successful.
    DIM mxlc AS MIXERLINECONTROLS
    DIM mxl  AS MIXERLINE

    mxl.cbStruct = SIZEOF(mxl)
    mxl.dwComponentType = componentType&

  ' Obtain a line corresponding to the component type
    rc& = mixerGetLineInfo(hmixer&, mxl, %MIXER_GETLINEINFOF_COMPONENTTYPE)

    FUNCTION = %False
    IF rc& = %MMSYSERR_NOERROR THEN
       mxlc.cbStruct = SIZEOF(mxlc)
       mxlc.dwLineID = mxl.dwLineID
       mxlc.dwControl = ctrlType&
       mxlc.cControls = 1
       mxlc.cbmxctrl = SIZEOF(mxc)

     ' Allocate a buffer for the control
       hMem& = GlobalAlloc(&H40, SIZEOF(mxc))
       mxlc.pamxctrl = GlobalLock(hMem&)
       mxc.cbStruct = SIZEOF(mxc)

     ' Get the control
       rc& = mixerGetLineControls(hmixer&, mxlc, %MIXER_GETLINECONTROLSF_ONEBYTYPE)

       IF rc& = %MMSYSERR_NOERROR THEN
          FUNCTION = %True
        ' Copy the control into the destination structure
          CALL CopyMemory(mxc, BYVAL mxlc.pamxctrl, SIZEOF(mxc))
       END IF
       CALL GlobalFree (hmem&)
    END IF
END FUNCTION

FUNCTION skSetMasterVolume&(BYVAL hmixer&, mxc As MIXERCONTROL, BYVAL volume&) EXPORT

  ' This function sets the value for a volume control. Returns True if successful

    DIM mxcd As MIXERCONTROLDETAILS
    DIM vol As MIXERCONTROLDETAILS_UNSIGNED

    mxcd.item = 0
    mxcd.dwControlID = mxc.dwControlID
    mxcd.cbStruct = SIZEOF(mxcd)
    mxcd.cbDetails = SIZEOF(vol)

  ' Allocate a buffer for the control value buffer
    hmem& = GlobalAlloc(&H40, SIZEOF(vol))
    mxcd.paDetails = GlobalLock(hmem&)
    mxcd.cChannels = 1
    vol.dwValue = volume&

  ' Copy the data into the control value buffer
    CALL CopyMemory (BYVAL mxcd.paDetails, vol, SIZEOF(vol))

  ' Set the control value
    rc& = mixerSetControlDetails(hmixer&, mxcd, %MIXER_SETCONTROLDETAILSF_VALUE)

    CALL GlobalFree (hmem&)
    IF rc& = %MMSYSERR_NOERROR THEN
       FUNCTION = %TRUE
    ELSE
       FUNCTION = %FALSE
    END IF
END FUNCTION

FUNCTION skGetMasterVolume&(BYVAL hmix&, mxc AS MIXERCONTROL) EXPORT

    DIM md AS MIXERCONTROLDETAILS
  ' Get the volume control
    ok& = GetVolumeControl(hmix&, _
                           %MIXERLINE_COMPONENTTYPE_DST_SPEAKERS, _
                           %MIXERCONTROL_CONTROLTYPE_VOLUME, _
                           mxc)
    md.cbStruct = SIZEOF(md)
    md.dwControlID = mxc.dwControlID
    md.cChannels = 1
    md.item = 0

    Volume& = 0
    md.cbDetails = SIZEOF(Volume&)
    md.paDetails = VARPTR(Volume&)

    rc& = mixerGetControlDetails(hmix&, md, %MIXER_GETCONTROLDETAILSF_VALUE)
    FUNCTION = Volume&

END FUNCTION

FUNCTION CDPlay& (Fplaying&) EXPORT
    Fplaying& = 0
    Ret& = mciSendString("Open CDAudio", BYVAL %NULL, BYVAL %NULL, BYVAL %NULL)
    Ret& = mciSendString("Play CDAudio", BYVAL %NULL, BYVAL %NULL, BYVAL %NULL)
    IF Ret& = 0 THEN Fplaying& = -1
    FUNCTION = Ret&
END FUNCTION

FUNCTION CDStop& (Fplaying&) EXPORT
    Ret& = mciSendString("Stop CDAudio", BYVAL %NULL, BYVAL %NULL, BYVAL %NULL)
    FUNCTION = mciSendString("Close CDAudio", BYVAL %NULL, BYVAL %NULL, BYVAL %NULL)
    Fplaying& = 0
END FUNCTION

FUNCTION CDInit&(Fplaying&) EXPORT
    CALL CDStop(Fplaying&)
    FUNCTION = CDPlay(Fplaying&)
END FUNCTION

FUNCTION CDEject& (Fplaying&) EXPORT
  ' This function is not supported by all CD devices.
    FUNCTION = mciSendString("Set CDAudio Door Open", "", 0, 0)
    Fplaying& = 0
END FUNCTION

FUNCTION CDInsert& (Fplaying&) EXPORT
  ' This function is not supported by all CD devices.
    FUNCTION = mciSendString("Set CDAudio Door Closed", "", 0, 0)
    Fplaying& = 0
END FUNCTION

FUNCTION CDPause& (Fplaying&) EXPORT
    FUNCTION = mciSendString("Stop CDAudio", "", 0, 0)
    Fplaying& = 0
END FUNCTION

FUNCTION CDTrackNext&(Fplaying&) EXPORT
    LOCAL zRet AS ASCIIZ * 64

    IF Fplaying& = 0 THEN EXIT FUNCTION

  ' Set time format to Tracks, minutes, seconds, and frames.
    Ret& = mciSendString("Set CDAudio Time Format TMSF", "", 0, 0)

  ' Retrieve the track number that is currently playing, and
  ' the total number of tracks on the CD. Store these values
  ' in global variables so that they are available to the form.
    Ret& = mciSendString("Status CDAudio Current Track", zRet, SIZEOF(zRet), 0)
    gTrackCurrent& = Val(zRet)
    TrackNext& = gTrackCurrent& + 1
    Ret& = mciSendString("Status CDAudio Number of Tracks", zRet, SIZEOF(zRet), 0)
    gTrackCount& = Val(zRet)

  ' Check to see if the current track is the last track. If it
  ' is seek to the beginning of the last track and play it.
  ' Otherwise, move to the next track and play from there to the end
  ' of the CD.
    IF TrackNext& < gTrackCount& THEN
       zTmp = "Play CDAudio from" + STR$(TrackNext&) + " To" + STR$(gTrackCount&)
       FUNCTION = mciSendString(zTmp, "", 0, 0)
    ELSE
       zTmp = "Seek CDAudio to" + STR$(gTrackCurrent&)
       Ret& = mciSendString(zTmp, "", 0, 0)
       FUNCTION = mciSendString("Play CDAudio", "", 0, 0)
    END IF

END FUNCTION

FUNCTION CDFastForward&(Fplaying&) EXPORT
    LOCAL zRet AS ASCIIZ * 64

    IF Fplaying& = 0 THEN EXIT FUNCTION

    FastForwardSpeed& = 5
    Ret& = mciSendString("Set CDAudio time format milliseconds", "", 0, 0)

    Ret& = mciSendString("Status CDAudio position wait", zRet, SIZEOF(zRet), 0)

    zTmp = "Play CDAudio from" + STR$(VAL(zRet) + FastForwardSpeed& * 1000)
    Ret& = mciSendString(zTmp, "", 0, 0)

  ' Set time format to Tracks, minutes, seconds, and frames.
    Ret& = mciSendString("Set CDAudio Time Format TMSF", "", 0, 0)

END FUNCTION

FUNCTION CDRewind&(Fplaying&) EXPORT
    LOCAL zRet AS ASCIIZ * 64

    IF Fplaying& = 0 THEN EXIT FUNCTION

    FastForwardSpeed& = 5
    Ret& = mciSendString("Set CDAudio time format milliseconds", "", 0, 0)

    Ret& = mciSendString("Status CDAudio position wait", zRet, SIZEOF(zRet), 0)

    zTmp = "Play CDAudio from" + STR$(VAL(zRet) - FastForwardSpeed& * 1000)
    Ret& = mciSendString(zTmp, "", 0, 0)

  ' Set time format to Tracks, minutes, seconds, and frames.
    Ret& = mciSendString("Set CDAudio Time Format TMSF", "", 0, 0)

END FUNCTION

FUNCTION CDTrackPrevious&(Fplaying&) EXPORT
    LOCAL zRet AS ASCIIZ * 64

    IF Fplaying& = 0 THEN EXIT FUNCTION

  ' Set time format to Tracks, minutes, seconds, and frames.
    Ret& = mciSendString("Set CDAudio Time Format TMSF", "", 0, 0)

  ' Retrieve the track number that is currently playing, and
  ' the total number of tracks on the CD. Store these values
  ' in global variables so that they are available to the form.
    Ret& = mciSendString("Status CDAudio Current Track", zRet, SIZEOF(zRet), 0)
    gTrackCurrent& = Val(zRet)
    TrackPrevious& = gTrackCurrent& - 1
    Ret& = mciSendString("Status CDAudio Number of Tracks", zRet, SIZEOF(zRet), 0)
    gTrackCount& = Val(zRet)

  ' Check to see if the current track is the first track. If it
  ' is seek to the beginning of the current track and play it.
  ' Otherwise, move to the previous track and play from there to
  ' the end of the CD.
    IF TrackPrevious& > 0 THEN
       zTmp = "Play CDAudio from" + STR$(TrackPrevious&) + " To" + STR$(gTrackCount&)
       FUNCTION = mciSendString(zTmp, "", 0, 0)
    ELSE
       zTmp = "Seek CDAudio to" + STR$(TrackPrevious&)
       Ret& = mciSendString(zTmp, "", 0, 0)
       CDTrackPrevious& = mciSendString("Play CDAudio", "", 0, 0)
    END IF

END FUNCTION

SUB Config(x&, y&, Wdth&, Hght&, BYVAL Action?)
'
' IF Action? = 0  read frame coordinates
' IF Action? <> 0 save frame coordinates

    CALL skSplitN(skExeName, TruePath$, TrueName$)
    IniFile$ = TruePath$ + EXTRACT$(TrueName$, ".") + ".CFG"

    IF Action? = 0 THEN          ' Read x y frame coordinates
       IF skExist(IniFile$) THEN
	  ErrCode& = skFOpen&(IniFile$, 0, 0, hFile&)
	  IF ErrCode& = 0 THEN Size& = skFlof(hFile&)
       END IF
       IF Size& THEN
	  Buff$ = SPACE$(Size&)
	  ErrCode& = skFGet(hFile&, Buff$)
	  x& = MAX(CVI(MID$(Buff$, 1, 2)), 0)
	  y& = MAX(CVI(MID$(Buff$, 3, 2)), 0)
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
       ELSE
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
          x& = MAX&((ScrWidth& - xFrame&) \ 2, 0)
          y& = MAX&((ScrHeight& - yFrame&) \ 2, 0)
       END IF
    ELSE                        ' Save x y frame coordinates
       CALL skKillFile(IniFile$)
       ErrCode& = skFOpen&(IniFile$, 1, 1, hFile&)
       IF ErrCode& = 0 THEN
	  Buff$ = MKI$(x&) + MKI$(y&) + MKI$(Wdth&) + MKI$(Hght&)
	  ErrCode& = skFPut(hFile&, Buff$)
       END IF
    END IF
    CALL skFClose(hFile&)
    Buff$ = ""

END SUB
